;MLC (Multi-platform Language for Calculators) by Epic Programming Studios
;TI-86 interpreter
;Written by Donald Straney (burntfuse) - straney@umbi.umd.edu

;Data

tok_header_str: .db $01
header_str: .db "MLC:",$d6,0 ;header used at the beginning of all MLC programs
version_str: .db "27"	;"version 2.7", used for identifying compressed progs

str_main: .db "MAIN"	;important vars, etc.
str_main_len	equ	4
str_mdl: .db "$MDL"
str_mdl_len		equ	4
str_ti86: .db "TI86",0
str_ti86_len	equ	5

str_cursor: .db Lunderscore,0

exec_str_name: .db $07,"mlcexec"	;names of external files
shell_str_name: .db $08,"mlcshell"
stext_str_name: .db $08,"mlcstext"
tokenize_str_name: .db $06,"mlctok"
err_str_name: .db $06,"mlcerr"

temp_name: .db $04,$10,"tmp"		;name of file used for temp data w/READ, WRTE, RUNP

blank_data: .db 0			;used for blank array data
blank_data1: .db 1
eof: .db eof_token			;used as fake EOF for write_ptr when returning from RUNP

option_menu_text_lines	equ	7
option_menu_text:
.db " MLC  IN-GAME  OPTION  MENU",0,0
.db "F1 - Return to game",0
.db "F2 - Exit game",0
.db "F3 - Turn off calculator",0
.db "F4 - Adjust speed",0
.db "F5 - Adjust contrast",0

exec_handler_table:		;holds address of handler for each command
.dw err_int		;data
.dw err_syntax	;dend
.dw 0	;exec_c_arry
.dw 0	;exec_c_size
.dw clr_buf		;clrs
.dw 0	;exec_c_text
.dw 0	;exec_c_line
.dw 0	;exec_c_pixl
.dw 0	;exec_c_pixt
.dw 0	;exec_c_rect
.dw 0	;exec_c_shft
.dw copy_scrn	;draw
.dw 0	;exec_c_stop
.dw 0	;exec_c_rclp
.dw 0	;exec_c_gkey
.dw 0	;exec_c_wkey
.dw 0	;exec_c_paus
.dw 0	;exec_c_inpt
.dw exec_ret	;fnct
.dw 0	;exec_c_frun
.dw 0	;exec_c_fend
.dw 0	;exec_c_fgob
.dw exec_c_if
.dw err_syntax	;then
.dw exec_ret	;ifnd
.dw exec_halt
.dw 0	;exec_c_wait
.dw 0	;exec_c_rset
.dw 0	;exec_c_rndm
.dw 0	;exec_c_polr
.dw 0	;exec_c_absl
.dw 0	;exec_c_subs
.dw 0	;exec_c_cint
.dw 0	;exec_c_disp
.dw err_syntax	;bitm
.dw 0	;exec_c_sprt
.dw 0	;exec_c_dbmp
.dw 0	;exec_c_clsn
.dw 0	;exec_c_nmap
.dw 0	;exec_c_tile
.dw 0	;exec_c_cmap
.dw 0	;exec_c_tchk
.dw 0	;exec_c_dmap
.dw 0	;exec_c_wrte
.dw 0	;exec_c_read
;.dw exec_c_runp

key_table:			;table w/direct input values vs. scancode
.db k_g7,k_left,24
.db k_g7,k_up,25
.db k_g7,k_right,26
.db k_g7,k_down,34
.db k_g1,k_2nd,21
.db k_g2,k_alpha,31
.db k_g1,k_more,23
.db k_g1,k_exit,22

.db k_g1,k_f1,11
.db k_g1,k_f2,12
.db k_g1,k_f3,13
.db k_g1,k_f4,14
.db k_g1,k_f5,15

.db k_g3,k_xvar,32
.db k_g4,k_del,33

.db k_g2,k_log,41
.db k_g3,k_sin,42
.db k_g4,k_cos,43
.db k_g5,k_tan,44
.db k_g6,k_exp,45

.db k_g2,k_ln,51
.db k_g3,k_ee,52
.db k_g4,k_lparen,53
.db k_g5,k_rparen,54
.db k_g6,k_div,55

.db k_g2,k_x2,61
.db k_g3,k_7,62
.db k_g4,k_8,63
.db k_g5,k_9,64
.db k_g6,k_mult,65

.db k_g2,k_comma,71
.db k_g3,k_4,72
.db k_g4,k_5,73
.db k_g5,k_6,74
.db k_g6,k_sub,75

.db k_g2,k_sto,81
.db k_g3,k_1,82
.db k_g4,k_2,83
.db k_g5,k_3,84
.db k_g6,k_add,85

.db k_g3,k_0,92
.db k_g4,k_period,93
.db k_g5,k_neg,94
.db k_g6,k_enter,95

.db 0,0,0

;trig_table:
;1000*cos x, 1000*sin x
;.dw 1000,0		;0
;.dw 966,259		;15
;.dw 866,500		;30
;.dw 707,707		;45
;.dw 500,866		;60
;.dw 259,966		;75
;.dw 0,1000		;90
;.dw -259,966	;105
;.dw -500,866	;120
;.dw -707,707	;135
;.dw -866,500	;150
;.dw -966,259	;165
;.dw -1000,0		;180
;.dw -966,-259	;195
;.dw -866,-500	;210
;.dw -707,-707	;225
;.dw -500,-866	;240
;.dw -259,-966	;255
;.dw 0,-1000		;270
;.dw 259,-966	;285
;.dw 500,-866	;300
;.dw 707,-707	;315
;.dw 866,-500	;330
;.dw 966,-259	;345
;.dw 1000,0		;360

input_str_keys_alpha:		;keycode-to-char conversion for INPT command (alpha mode)
.db 41,LcapA
.db 42,LcapB
.db 43,LcapC
.db 44,LcapD
.db 45,LcapE
.db 51,LcapF
.db 52,LcapG
.db 53,LcapH
.db 54,LcapI
.db 55,LcapJ
.db 61,LcapK
.db 62,LcapL
.db 63,LcapM
.db 64,LcapN
.db 65,LcapO
.db 71,LcapP
.db 72,LcapQ
.db 73,LcapR
.db 74,LcapS
.db 75,LcapT
.db 82,LcapU
.db 83,LcapV
.db 84,LcapW
.db 85,LcapX
.db 92,LcapY
.db 93,LcapZ
.db 94,Lspace
.db 0

input_str_keys_num:				;same (number mode)
.db 92,L0
.db 82,L1
.db 83,L2
.db 84,L3
.db 72,L4
.db 73,L5
.db 74,L6
.db 62,L7
.db 63,L8
.db 64,L9
.db 71,Lcomma
.db 55,Lslash
.db 65,Lasterisk
.db 75,Ldash
.db 85,LplusSign
.db 0

token_list:
.pad $+dyn_cmd_num

.end