;MLC (Multi-platform Language for Calculators) by Epic Programming Studios
;TI-86 interpreter
;Written by Donald Straney (burntfuse) - straney@umbi.umd.edu

;Error text (compiled to separate string)

.plugin bin

.org $b230

str_err: .db "ERROR!",0			;error title
str_line: .db "line ",0

;error messages
str_frun: .db 1,"stack overflow",0
str_argrange: .db 1,"argument out of range",0
str_syntax: .db 1,"syntax error",0
str_eol: .db 1,"end of line expected",0
str_var: .db 1,"variable name expected",0
str_var_int: .db 2,"integer variable",0,"or array element expected",0
str_var_arry: .db 1,"array variable expected",0
str_var_str: .db 1,"string variable expected",0
str_vartype: .db 1,"wrong variable type",0
str_num: .db 1,"number expected",0
str_op: .db 1,"unrecognized operator",0
str_spr_prop: .db 1,"sprite property expected",0
str_bmp: .db 1,"bitmap name expected",0
str_spr: .db 1,"sprite name expected",0
str_str: .db 1,"string expected",0
str_nomain: .db 1,"program must have function 'MAIN'",0
str_invcmd: .db 1,"unrecognized command",0
str_invarg: .db 1,"unrecognized argument type",0
str_invop: .db 1,"unrecognized operator",0
;str_namelen: .db 2,"name is too long",0,"(must be 1-5 characters)",0
str_namelen: .db 1,"name is too long",0
;str_numlen: .db 2,"number is too long",0,"(must be from -32768 to +32768)",0
str_numlen: .db 1,"number is too long",0
str_mem_var: .db 1,"too many variables",0
str_mem_lbl: .db 1,"too many functions",0
str_nolbl: .db 1,"function doesn't exist",0
str_keycode: .db 1,"invalid keycode",0
str_num_key: .db 1,"keycode expected",0
str_mem: .db 1,"out of internal memory",0
str_mem_file: .db 2,"not enough memory",0,"to expand file",0
str_arraylen: .db 1,"arrays must have 1 to 255 elements",0
str_maplen: .db 2,"tilemaps must have heights",0,"and widths from 1 to 255",0
;str_arrayindex: .db 1,"array or map index out of bounds",0
str_arrayindex: .db 1,"index out of bounds",0
str_noarray: .db 1,"array or map hasn't been defined",0
;str_strlen: .db 2,"string is too long",0,"(must be <36 characters)",0
str_strlen: .db 1,"string is too long",0
;str_mem_bmp: .db 2,"not enough memory",0,"to create bitmap",0
str_mem_bmp: .db 1,"too many bitmaps",0
str_sprformat: .db 1,"incorrect bitmap format",0
str_nobmp: .db 1,"bitmap doesn't exist",0
str_mem_spr: .db 1,"too many sprites",0
str_nospr: .db 1,"sprite hasn't been defined",0
;str_progname: .db 2,"program name is too long",0,"(must be <8 characters)",0
str_progname: .db 1,"program name is too long",0
str_twovar_arry: .db 2,"array or map has already",0,"been created",0
str_twovar_spr: .db 1,"bitmap has already been defined",0
;str_deflen: .db 2,"definition must have",0,"same length as variable",0
str_deflen: .db 2,"array or map definition has",0,"wrong length",0
str_int: .db 1,"internal error",0
;str_cint: .db 2,"string cannot be converted to number:",0,"invalid character",0
str_cint: .db 1,"invalid character in string",0
;str_noptr: .db 2,"pointer has not been assigned",0,"a variable, sprite, or bitmap",0
str_noptr: .db 1,"pointer has not been defined",0
str_ptr: .db 1,"pointer name expected",0
str_map: .db 1,"tilemap name expected",0
str_map8: .db 1,"only 8x8 sprites allowed in maps",0
str_version: .db 2,"this program was compressed with",0,"a different version of MLC86",0
str_noprog: .db 1,"program doesn't exist",0
str_handlermem: .db 1,"too many commands",0

.end